#### Previous topic

scipy.signal.tf2sos

#### Next topic

scipy.signal.zpk2tf

# scipy.signal.tf2ss

`scipy.signal.``tf2ss`(num, den)

  Transfer function to state-space representation.

  Parameters:

  num, den : array_like

  > Sequences representing the numerator and denominator polynomials. The denominator needs to be at least as long as the numerator.

  Returns:

  A, B, C, D : ndarray

  > State space representation of the system, in controller canonical form.

  Examples

  Convert the transfer function:

  \[H(s) = \frac{s^2 + 3s + 3}{s^2 + 2s + 1}\]

      >>> num = [1, 3, 3]
      >>> den = [1, 2, 1]

  to the state-space representation:

  \[\begin{split}\dot{\textbf{x}}(t) = \begin{bmatrix} -2 & -1 \\ 1 & 0 \end{bmatrix} \textbf{x}(t) + \begin{bmatrix} 1 \\ 0 \end{bmatrix} \textbf{u}(t) \\\end{split}\]\[\begin{split}\textbf{y}(t) = \begin{bmatrix} 1 & 2 \end{bmatrix} \textbf{x}(t) + \begin{bmatrix} 1 \end{bmatrix} \textbf{u}(t)\end{split}\]

      >>> from scipy.signal import tf2ss
      >>> A, B, C, D = tf2ss(num, den)
      >>> A
      array([[-2., -1.],
             [ 1.,  0.]])
      >>> B
      array([[ 1.],
             [ 0.]])
      >>> C
      array([[ 1.,  2.]])
      >>> D
      array([ 1.])